#include <stdio.h>

int m,n;
char arr[100][100];

void print(int x, int y, char c){
	if(x>=0 && y>=0 && x<m && y<m) arr[x][y] = c;
}

int max(int a, int b){
	return a>b?a:b;
}

void tree(int s, int x, int y){
	if (x<-1 || x>m) return;
	print(x,y,(char)124);
	print(x-1,y,(char)95);
	print(x+1,y,(char)95);
	int bound = max(0, -(y+1));
	for(int i=bound; i<s && y+i+1<m; i++){
		print(x,y+1+i, (char)124);
		print(x-1,y+1+i, (char)47);
		print(x+1,y+1+i, (char)92);
	}
	print(x, y+s+1, (char)94);
}

void bush(int x, int y){
	print(x,y, (char)111);
	print(x-1,y,(char)95);
	print(x+1,y,(char)95);
}

int main(){
	while(scanf("%d%d", &m, &n)>=0){
		for (int i=0;i<m;i++){
			for (int j=0;j<m;j++){
				arr[i][j] = '.';
			}
		}
		
		for(int i=0;i<n;i++){
			int s,x,y;
			scanf("%d%d%d", &s, &x, &y);
			if (s!=0)tree(s,x,y);
			else bush(x,y);
		}
		for(int i=0;i<m+2;i++){
			printf("*");
		}
		printf("\n");
		
		for(int i=m-1;i>=0;i--){
			printf("*");
			for(int j=0;j<m;j++){
				printf("%c", arr[j][i]);
			}
			printf("*\n");
		}
		
		for(int i=0;i<m+2;i++){
			printf("*");
		}
		printf("\n\n");
	}
}
